Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# SolutionRequest Class Reference

Manages runtime exchangeable modules. More...

`#include <SolutionRequest.h>`

List of all members.

## Public Types
enum | ModuleID { colorTableMod, sensorDataProcessor, imageProcessor, ballLocator, teamBallLocator, obstaclesLocator, playersLocator, selfLocator, robotStateDetector, collisionDetector, behaviorControl, motionControl, walkingEngineNormal, headControl, ledControl, getupEngine, soundControl, sensorBehaviorControl, gtCam, numOfModules }
| Enumerator for exchange modules Add new exchangeable module here. More...
enum | ModuleSolutionID { disabled = -1, colorTable64Mod = 0, colorTable32KMod, numOfColorTableModSolutions, gt2005SelfLocator = 0, gt2005StableSelfLocator, gt2004SelfLocator, gtCamSelfLocator, odometrySelfLocator, slamSelfLocator, comboSelfLocator, numOfSelfLocatorSolutions, gt2005ImageProcessor = 0, slamImageProcessor, vlcImageProcessor, numOfImageProcessorSolutions, gt2005BehaviorControlAgentSoccer = 0, gt2005BehaviorControlAgentPenaltyShooter, gt2005BehaviorControlAgentPenaltyShooter2, gt2005BehaviorControlAgentPenaltyGoalie, gt2005BehaviorControlAgentJoystickControlled, gt2005BehaviorControlAgentSlamChallange, gt2005BehaviorControlAgentVLCshooter, gt2005BehaviorControlAgentVLC2shooter, gt2005BehaviorControlAgentObstacleAvoidanceChallange03, gt2005BehaviorControlAgentOdometryTester, gt2005BehaviorControlAgentGuideDog, gt2005BehaviorControlAgentBlindDog, gt2005BehaviorControlAgentKickLogger, gt2005BehaviorControlAgentBasicsTester, numOfBehaviorControlSolutions, gt2005CollisionDetector = 0, numOfCollisionDetectorSolutions, gt2005WalkingEngine = 0, gt2004WalkingEngine, invKinUpsideDownWalkingEngine, invKinTurnWithBallWalkingEngine, invKinTurnKickWalkingEngine, numOfWalkingEngineSolutions, gt2005BallLocator = 0, gtCamBallLocator, numOfBallLocatorSolutions, gt2005TeamBallLocator = 0, numOfTeamBallLocatorSolutions, gtCamPlayersLocator, numOfPlayersLocatorSolutions, gt2005ObstaclesLocator = 0, gtCamObstaclesLocator, numOfObstaclesLocatorSolutions, gt2005HeadControl = 0, numOfHeadControlSolutions, gt2005LEDControl = 0, numOfLEDControlSolutions, gt2005SensorDataProcessor = 0, numOfSensorDataProcessorSolutions, gt2005RobotStateDetector = 0, numOfRobotStateDetectorSolutions, dummySensorBehaviorControl = 0, numOfSensorBehaviorControlSolutions, gt2005MotionControl = 0, debugMotionControl, numOfMotionControlSolutions, gt2005GetupEngine = 0, numOfGetupEngineSolutions, gt2005SoundControl = 0, numOfSoundControlSolutions, gtCamRaw = 0, numOfGTCamSolutions }
| enumerator for available solutions for all exchangeable modules Attention: add new solutions here dont forget to edit selector module too More...
enum | xabsl2EngineID { gt2005, numOfXabslBehaviors, hc_gt2005 = numOfXabslBehaviors, undefined }
| IDs for the module solutions using a Xabsl2Engine. More...
## Public Member Functions
| SolutionRequest (bool setDefault=false)
| Constructor.
void | setDefaultSolutions ()
| Sets all modules to default solutions.
bool | operator== (const SolutionRequest &other)
| the == operator
bool | operator!= (const SolutionRequest &other)
| the == operator
## Static Public Member Functions
const char * | getModuleName (ModuleID id)
| returns names for module ids Add new exchangeable module here
const char * | getModuleCategoryName (ModuleID id)
| returns categories for module ids Add new exchangeable module here
int | getNumOfSolutions (ModuleID id)
| Returns number of solutions in module id Attention: add new exchangeable module here.
const char * | getModuleSolutionName (ModuleID module, ModuleSolutionID solution)
| Returns names for module solution ids.
ModuleSolutionID | getDefaultSolution (ModuleID id)
| Returns default solution for module.
const char * | getXabsl2EngineIDName (xabsl2EngineID id)
| returns the name of a xabsl2EngineID
const char * | getXabsl2EngineFileID (xabsl2EngineID id)
| returns the beginning of the file name of a config file for a xabsl2Engine
## Public Attributes
ModuleSolutionID | solutions [numOfModules]
| an array containing the selected solution for each module
bool | errorWhileReading
| ErrorWhileReading is set to true when an error occurred while reading the SolutionRequest eg when an module was missing or a solution was not recognized.

## Detailed Description

Manages runtime exchangeable modules.

Definition at line 19 of file SolutionRequest.h.

## Member Enumeration Documentation

enum SolutionRequest::ModuleID

  | Enumerator for exchange modules Add new exchangeable module here. Create new selector module for new exchangeable modules Enumeration values:
  colorTableMod |
  sensorDataProcessor | See class SensorDataProcessorSelector
  imageProcessor | See class ImageProcessorSelector
  ballLocator | See class BallLocatorSelector
  teamBallLocator | See class TeamBallLocatorSelector
  obstaclesLocator | See class ObstaclesLocatorSelector
  playersLocator | See class PlayersLocatorSelector
  selfLocator | See class SelfLocatorSelector
  robotStateDetector | See class RobotStateDetectorSelector
  collisionDetector | See class CollisionDetectorSelector
  behaviorControl | See class BehaviorControlSelector
  motionControl | See class MotionControlSelector
  walkingEngineNormal | See class WalkingEngineNormalSelector
  headControl | See class HeadControlSelector
  ledControl | See class LEDControlSelector
  getupEngine | See class GetupEngineSelector
  soundControl | See class SoundControlSelector
  sensorBehaviorControl | See class SensorBehaviorControlSelector
  gtCam | See class GTCamSelector
  numOfModules | Number of exchangeable modules
Definition at line 27 of file SolutionRequest.h.

enum SolutionRequest::ModuleSolutionID

  | enumerator for available solutions for all exchangeable modules Attention: add new solutions here dont forget to edit selector module too Enumeration values:
  disabled |
  colorTable64Mod |
  colorTable32KMod |
  numOfColorTableModSolutions |
  gt2005SelfLocator |
  gt2005StableSelfLocator |
  gt2004SelfLocator |
  gtCamSelfLocator |
  odometrySelfLocator |
  slamSelfLocator |
  comboSelfLocator |
  numOfSelfLocatorSolutions |
  gt2005ImageProcessor |
  slamImageProcessor |
  vlcImageProcessor |
  numOfImageProcessorSolutions |
  gt2005BehaviorControlAgentSoccer |
  gt2005BehaviorControlAgentPenaltyShooter |
  gt2005BehaviorControlAgentPenaltyShooter2 |
  gt2005BehaviorControlAgentPenaltyGoalie |
  gt2005BehaviorControlAgentJoystickControlled |
  gt2005BehaviorControlAgentSlamChallange |
  gt2005BehaviorControlAgentVLCshooter |
  gt2005BehaviorControlAgentVLC2shooter |
  gt2005BehaviorControlAgentObstacleAvoidanceChallange03 |
  gt2005BehaviorControlAgentOdometryTester |
  gt2005BehaviorControlAgentGuideDog |
  gt2005BehaviorControlAgentBlindDog |
  gt2005BehaviorControlAgentKickLogger |
  gt2005BehaviorControlAgentBasicsTester |
  numOfBehaviorControlSolutions |
  gt2005CollisionDetector |
  numOfCollisionDetectorSolutions |
  gt2005WalkingEngine |
  gt2004WalkingEngine |
  invKinUpsideDownWalkingEngine |
  invKinTurnWithBallWalkingEngine |
  invKinTurnKickWalkingEngine |
  numOfWalkingEngineSolutions |
  gt2005BallLocator |
  gtCamBallLocator |
  numOfBallLocatorSolutions |
  gt2005TeamBallLocator |
  numOfTeamBallLocatorSolutions |
  gtCamPlayersLocator |
  numOfPlayersLocatorSolutions |
  gt2005ObstaclesLocator |
  gtCamObstaclesLocator |
  numOfObstaclesLocatorSolutions |
  gt2005HeadControl |
  numOfHeadControlSolutions |
  gt2005LEDControl |
  numOfLEDControlSolutions |
  gt2005SensorDataProcessor |
  numOfSensorDataProcessorSolutions |
  gt2005RobotStateDetector |
  numOfRobotStateDetectorSolutions |
  dummySensorBehaviorControl |
  numOfSensorBehaviorControlSolutions |
  gt2005MotionControl |
  debugMotionControl |
  numOfMotionControlSolutions |
  gt2005GetupEngine |
  numOfGetupEngineSolutions |
  gt2005SoundControl |
  numOfSoundControlSolutions |
  gtCamRaw |
  numOfGTCamSolutions |
Definition at line 55 of file SolutionRequest.h. Referenced by getDefaultSolution().

enum SolutionRequest::xabsl2EngineID

  | IDs for the module solutions using a Xabsl2Engine. Enumeration values:
  gt2005 |
  numOfXabslBehaviors |
  hc_gt2005 |
  undefined |
Definition at line 412 of file SolutionRequest.h.

## Constructor & Destructor Documentation

SolutionRequest::SolutionRequest | ( | bool | setDefault = false | ) |

  | Constructor. Parameters:
  setDefault | if true default modules will be selected else all modules are disabled
Definition at line 16 of file SolutionRequest.cpp. References errorWhileReading, setDefaultSolutions(), and solutions.

Here is the call graph for this function:

## Member Function Documentation

const char* SolutionRequest::getModuleName | ( | ModuleID | id | ) | `[inline, static]`

| returns names for module ids Add new exchangeable module here Definition at line 168 of file SolutionRequest.h. Referenced by operator<<(), and Process::processMain().

const char* SolutionRequest::getModuleCategoryName | ( | ModuleID | id | ) | `[inline, static]`

| returns categories for module ids Add new exchangeable module here Definition at line 199 of file SolutionRequest.h. Referenced by Process::processMain().

int SolutionRequest::getNumOfSolutions | ( | ModuleID | id | ) | `[inline, static]`

| Returns number of solutions in module id Attention: add new exchangeable module here. Definition at line 231 of file SolutionRequest.h. References numOfBallLocatorSolutions, numOfBehaviorControlSolutions, numOfCollisionDetectorSolutions, numOfColorTableModSolutions, numOfGetupEngineSolutions, numOfGTCamSolutions, numOfHeadControlSolutions, numOfImageProcessorSolutions, numOfLEDControlSolutions, numOfMotionControlSolutions, numOfObstaclesLocatorSolutions, numOfPlayersLocatorSolutions, numOfRobotStateDetectorSolutions, numOfSelfLocatorSolutions, numOfSensorBehaviorControlSolutions, numOfSensorDataProcessorSolutions, numOfSoundControlSolutions, numOfTeamBallLocatorSolutions, and numOfWalkingEngineSolutions. Referenced by operator<<(), operator>>(), and Process::processMain().

const char* SolutionRequest::getModuleSolutionName | ( | ModuleID | module,
|  | ModuleSolutionID | solution
| ) | `[inline, static]`

| Returns names for module solution ids. Add new solutions here. Definition at line 263 of file SolutionRequest.h. References colorTable32KMod, colorTable64Mod, comboSelfLocator, debugMotionControl, dummySensorBehaviorControl, gt2004SelfLocator, gt2004WalkingEngine, gt2005BallLocator, gt2005BehaviorControlAgentBasicsTester, gt2005BehaviorControlAgentJoystickControlled, gt2005BehaviorControlAgentKickLogger, gt2005BehaviorControlAgentObstacleAvoidanceChallange03, gt2005BehaviorControlAgentOdometryTester, gt2005BehaviorControlAgentPenaltyGoalie, gt2005BehaviorControlAgentPenaltyShooter, gt2005BehaviorControlAgentPenaltyShooter2, gt2005BehaviorControlAgentSlamChallange, gt2005BehaviorControlAgentSoccer, gt2005BehaviorControlAgentVLC2shooter, gt2005BehaviorControlAgentVLCshooter, gt2005CollisionDetector, gt2005GetupEngine, gt2005HeadControl, gt2005ImageProcessor, gt2005LEDControl, gt2005MotionControl, gt2005ObstaclesLocator, gt2005RobotStateDetector, gt2005SelfLocator, gt2005SensorDataProcessor, gt2005SoundControl, gt2005StableSelfLocator, gt2005WalkingEngine, gtCamBallLocator, gtCamObstaclesLocator, gtCamPlayersLocator, gtCamRaw, gtCamSelfLocator, invKinTurnKickWalkingEngine, invKinTurnWithBallWalkingEngine, invKinUpsideDownWalkingEngine, odometrySelfLocator, slamImageProcessor, slamSelfLocator, and vlcImageProcessor. Referenced by operator<<(), and Process::processMain().

ModuleSolutionID SolutionRequest::getDefaultSolution | ( | ModuleID | id | ) | `[inline, static]`

| Returns default solution for module. Definition at line 386 of file SolutionRequest.h. References ModuleSolutionID, and solutions. Referenced by ModuleSelector::ModuleSelector().

void SolutionRequest::setDefaultSolutions | ( |  | ) |

| Sets all modules to default solutions. Definition at line 30 of file SolutionRequest.cpp. References InStream< InFile, InConfig >::eof(), errorWhileReading, InFile::exists(), getLocation(), and solutions. Referenced by SolutionRequest().

Here is the call graph for this function:

bool SolutionRequest::operator== | ( | const SolutionRequest & | other | ) |

| the == operator Definition at line 48 of file SolutionRequest.cpp. References solutions.

bool SolutionRequest::operator!= | ( | const SolutionRequest & | other | ) | `[inline]`

| the == operator Definition at line 401 of file SolutionRequest.h.

const char* SolutionRequest::getXabsl2EngineIDName | ( | xabsl2EngineID | id | ) | `[inline, static]`

| returns the name of a xabsl2EngineID Definition at line 421 of file SolutionRequest.h. References gt2005, and hc_gt2005.

const char* SolutionRequest::getXabsl2EngineFileID | ( | xabsl2EngineID | id | ) | `[inline, static]`

| returns the beginning of the file name of a config file for a xabsl2Engine Definition at line 434 of file SolutionRequest.h. References gt2005, and hc_gt2005.

## Member Data Documentation

ModuleSolutionID SolutionRequest::solutions[numOfModules]

| an array containing the selected solution for each module Definition at line 376 of file SolutionRequest.h. Referenced by getDefaultSolution(), operator<<(), operator==(), operator>>(), ModuleHandler::selectSolutions(), setDefaultSolutions(), and SolutionRequest().

bool SolutionRequest::errorWhileReading

| ErrorWhileReading is set to true when an error occurred while reading the SolutionRequest eg when an module was missing or a solution was not recognized. Definition at line 409 of file SolutionRequest.h. Referenced by operator>>(), setDefaultSolutions(), and SolutionRequest().

The documentation for this class was generated from the following files:

- Tools/Module/SolutionRequest.h
- Tools/Module/SolutionRequest.cpp